<?php

/*
**************************************************
Interface: CachingStrategy_Interface.php
**************************************************
Author: Tsiavos Chris <jaames@freemail.gr>
Date: October 2004
**************************************************/

class CachingStrategy_Exception extends Exception {

	function CachingStrategy_Exception($data) {
		Exception::__construct($data);
	}
	
}

/**
*Interface for Caching Strategy Objects
*@interface
*@author Tsiavos Chris <jaames@freemail.gr>
*@license http://opensource.org/licenses/gpl-license.php GNU Public License
*/
Interface CachingStrategy_Interface {
	
	/**
	*Initializes the CachingStrategy Object.
	*@return void
	*@param string $CacheImageType The Content-Type value of the generated image
	*@param integer $CacheForMinutes The validity period of the cached image
	*@param mixed $Param Passes an arbitrary number of caching-specific parameters to the strategy object
	*/
	public function Initialize($CacheImageType,$CacheForMinutes,$Params);
	
	/**
	*Caches the generated image
	*/
	public function CacheImage();

}


?>