<?php

/*
**************************************************
Class: Shape.php
**************************************************
Author: Tsiavos Chris <jaames@freemail.gr>
Date: October 2004
**************************************************/

/**
*Base class for all kinds of shapes
*@abstract
*@author Tsiavos Chris <jaames@freemail.gr>
*@license http://opensource.org/licenses/gpl-license.php GNU Public License
*/

abstract class Shape {

	/**
	*reference to the image handler the shape will be drawn in
	*@access public
	*@var mixed
	*/
	protected $Canvas;
	
	/**
	*reference to the ColorAllocator the class will use for allocating the shape color
	*@access public
	*@var ColorAllocator
	*/
	protected $ColorAllocator;
	
	/**
	*whether antialias functions should be used or not when drawing the shape
	*@access protected
	*@var string
	*/
	protected $UseAntialias;
	
	function __construct(&$Canvas,ColorAllocator &$ColorAllocator,$UseAntialias) {
		$this->Canvas=$Canvas;
		$this->ColorAllocator=$ColorAllocator;
		$this->UseAntialias=$UseAntialias;
	}

}

?>